// QBufferDemoView.cpp : implementation of the CQBufferDemoView class
//

#include "stdafx.h"
#include "QBufferDemo.h"

#include "QBufferDemoView.h"
#include "QBufferDC.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#ifndef QBUFFER_DEMO
#error QBUFFER_DEMO undefined. See QBufferDC.h.
#endif

IMPLEMENT_DYNCREATE(CQBufferDemoView, CScrollView)

BEGIN_MESSAGE_MAP(CQBufferDemoView, CScrollView)
	ON_COMMAND(ID_DEMO_DEMOMODE, OnDemoDemomode)
	ON_UPDATE_COMMAND_UI(ID_DEMO_DEMOMODE, OnUpdateDemoDemomode)
END_MESSAGE_MAP()


CQBufferDemoView::CQBufferDemoView()
{
}

CQBufferDemoView::~CQBufferDemoView()
{
}

void CQBufferDemoView::OnDraw(CDC* pDC)
{
	// Create a QBufferDC, a buffer DC with a bitmap to do
	// all the drawing to.
	// When dcBuffer goes out of scope, QBufferDC's destructor
	// will BitBlt all graphics to the screen at one swoop,
	// eliminating all flicker.

	QBufferDC dcBuffer(pDC);


	// Send all graphics output to dcBuffer in stead of the screen dc (pDC).
	// That's really all there is to flickerfree drawing.
	// Some silly drawing code:

	CBrush brYellow(RGB(255, 255, 64));
	CBrush brSienna(RGB(128, 0, 0));
	CPen pen(PS_SOLID, 10, RGB(128, 0, 0));

	LOGFONT lf;
	::ZeroMemory(& lf, sizeof(LOGFONT));
	_tcscpy(lf.lfFaceName, _T("Georgia"));
	lf.lfHeight = 60;
	lf.lfWeight = FW_BOLD;

	CFont font;
	font.CreateFontIndirect(& lf);

	CBrush * pOldBrush = (CBrush *) dcBuffer.SelectObject(& brYellow);
	CPen * pOldPen = (CPen *) dcBuffer.SelectObject(& pen);
	CFont * pOldFont = (CFont *) dcBuffer.SelectObject(& font);

	dcBuffer.Ellipse(200, 350, 600, 750);

	dcBuffer.SelectObject(& brSienna);

	CRect rcEye(0, 0, 0, 0);
	rcEye.InflateRect(10, 10);
	rcEye.OffsetRect(330, 520);
	dcBuffer.Ellipse(rcEye);
	rcEye.OffsetRect(140, 0);
	dcBuffer.Ellipse(rcEye);

	CRect rcMouth(0, 0, 0, 0);
	rcMouth.InflateRect(60, 60);
	rcMouth.OffsetRect(400, 590);

	dcBuffer.Arc(rcMouth, CPoint(340, 600), CPoint(460, 600));

	CString sHello(_T("Hello world!"));
	dcBuffer.SetTextAlign(TA_CENTER);
	dcBuffer.SetTextColor(RGB(192, 64, 0));
	dcBuffer.TextOut(400, 260, sHello);

	lf.lfHeight = 36;
	lf.lfWeight = FW_NORMAL;

	CFont fontZoom;
	fontZoom.CreateFontIndirect(& lf);
	dcBuffer.SelectObject(& fontZoom);
	dcBuffer.SetTextColor(RGB(0, 0, 0));

	CString sDemo(_T("QBufferDC demonstration"));
	dcBuffer.TextOut(400, 780, sDemo);

	if (pOldFont) dcBuffer.SelectObject(pOldFont);
	if (pOldPen) dcBuffer.SelectObject(pOldPen);
	if (pOldBrush) dcBuffer.SelectObject(pOldBrush);

	// Here, dcBuffer goes out of scope.
	// It's destructor will BitBlt the accumulated
	// graphics tot the screen dc.
}

void CQBufferDemoView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;

	sizeTotal.cx = 800;
	sizeTotal.cy = 1000;

	SetScrollSizes(MM_TEXT, sizeTotal);
}

void CQBufferDemoView::OnDemoDemomode()
{
	QBufferDC::m_bDemoMode ^= TRUE;
	Invalidate();
}

void CQBufferDemoView::OnUpdateDemoDemomode(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(QBufferDC::m_bDemoMode);
}
